﻿using UnityEngine;
using System.Collections;

[RequireComponent(typeof(Camera))]
public class CameraMove : MonoBehaviour {

    [SerializeField]
    private Transform _LookAt;

    [SerializeField]
    private float _Speed = 1;

    private float _Rotation=-45, _CameraDistance;

	// Use this for initialization
	void Start () {
        _CameraDistance = Vector3.Distance(new Vector3(_LookAt.position.x, 0, _LookAt.position.z), new Vector3(transform.position.x, 0, transform.position.z));
	}
	
	// Update is called once per frame
	void LateUpdate () {
        if (Input.GetKey(KeyCode.D))
        {
            _Rotation = Mathf.Repeat(_Rotation + Time.deltaTime * _Speed, 360);
        }
        if (Input.GetKey(KeyCode.A))
        {
            _Rotation = Mathf.Repeat(_Rotation - Time.deltaTime * _Speed, 360);
        }

        _UpdateCameraPosition();
	}

    private void _UpdateCameraPosition()
    {
        float y = transform.position.y;
        transform.position = new Vector3(_LookAt.transform.position.x, transform.position.y, _LookAt.transform.position.z);

        transform.localEulerAngles = new Vector3(0, _Rotation,0);
        transform.position -= transform.forward * _CameraDistance;
        transform.LookAt(_LookAt);
    }
}
