﻿using UnityEngine;
using System.Collections;

public class Tile : MonoBehaviour {
    /// <summary>
    /// How long player must hold a button to place this block
    /// </summary>
    public float placementTime;

    /// <summary>
    /// How long th player must hold to remove this tile
    /// </summary>
    public float removeTime;

    /// <summary>
    /// Can this tile be built on
    /// </summary>
    public bool canBuild;

    protected GridManager parentGrid;

    private int row;
    private int col;

    public int strength;
    [SerializeField]
    protected bool flowable;
    [SerializeField]
    protected string _type;

    public GameObject UpgradesTo, DowngradesTo;


    // Use this for initialization
    void Start() {
    }

    // Update is called once per frame
    void Update() {

    }

    public void SetGrid(GridManager parent, int col, int row)
    {
        this.parentGrid = parent;
        this.col = col;
        this.row = row;
    }

    public int GetRow()
    {
        return row;
    }

    public int GetCol()
    {
        return col;
    }

    public int GetStrength()
    {
        return strength;
    }

    public virtual void SetStrength(int str)
    {
        strength = str;
    }

    public bool IsFlowable()
    {
        return flowable;
    }

    public string GetTileType()
    {
        return _type;
    }
}
