﻿using UnityEngine;
using System.Collections;

public class WaveSpawner : MonoBehaviour {

    private GridManager gridManager;

    [SerializeField]
    private GameObject waterTile;
    public int rowNum;
    public int tileStrength;
    public int topRow;

    //time between waves
    [SerializeField]
    private float _WaveTime = 5;

    private float _Timer;
    private int waveCount;

	// Use this for initialization
	void Start () {
        gridManager = FindObjectOfType<GridManager>();
        _Timer = _WaveTime;
        waveCount = 0;
    }
	
	// Update is called once per frame
	void Update () {
        if (_Timer >= 0)
        {
            _Timer -= Time.deltaTime;

            if (_Timer <= 0)
            {
                _SpawnWater();
                _Timer = _WaveTime;
            }
        }
	}

    private void _SpawnWater()
    {
        rowNum = Random.Range(0, gridManager.rows);

        gridManager.ReplaceTile(waterTile, gridManager.cols-1, rowNum).GetComponent<WaterController>().SetStrength(tileStrength);

        waveCount++;

        if (waveCount % 5 == 0)
        {
            _WaveTime /= 1.1f;
            tileStrength -= 2;
        }
        else if (waveCount % 2 == 0)
        {
            tileStrength += 1;
        }
    }
}
